#ifndef __DEV_UART4_H
#define __DEV_UART4_H

#include "hal_uart4.h"
#include <stdint.h>
#ifdef __cplusplus
extern 'C'
{
#endif
#ifdef __DEV_UART4_H_GLOBAL
#define __DEV_UART4_H_EXTERN
#else
#define __DEV_UART4_H_EXTERN extern
#endif

/************************************************************************************************
 *                                          Version                                              *
 ************************************************************************************************/

/************************************************************************************************
 *                                          How to use                                           *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Enable config                                         *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Includes                                             *
 ************************************************************************************************/

/************************************************************************************************
 *                                          Defines                                              *
 ************************************************************************************************/
#define UART_ARR_SIZE(a) sizeof(a) / sizeof((a)[0])

    typedef struct
    {
        uint8_t cmd;
        uint8_t (*p_func)(uart_type *data);
    } com_protocol_type;

    void uart_task(void);

/************************************************************************************************
 *                                          Defines                                              *
 ************************************************************************************************/
#ifdef __cplusplus
};
#endif

#endif // __DEV_UART4_H
