#ifndef __DEV──UART──TABLE_H
#define __DEV──UART──TABLE_H

#include "hal_uart4.h"
#include <stdint.h>
#ifdef __cplusplus
extern 'C'
{
#endif
#ifdef __DEV──UART──TABLE_H_GLOBAL
#define __DEV──UART──TABLE_H_EXTERN
#else
#define __DEV──UART──TABLE_H_EXTERN extern
#endif

    /************************************************************************************************
     *                                          Version                                              *
     ************************************************************************************************/

    /************************************************************************************************
     *                                          How to use                                           *
     ************************************************************************************************/

    /************************************************************************************************
     *                                          Enable config                                         *
     ************************************************************************************************/

    /************************************************************************************************
     *                                          Includes                                             *
     ************************************************************************************************/

    /************************************************************************************************
     *                                          Defines                                              *
     ************************************************************************************************/
    typedef struct
    {
        uint16_t addr;
        void (*p_func)(uint8_t memoft, uint8_t *data, uint8_t *read_bytes);
    } regist_read_type;

    uint8_t get_regist_value(uart_type * p_data, uint8_t mem_start_addr, uint8_t read_len);
    uint8_t set_regist_value(uart_type * p_data, uint8_t mem_start_addr, uint8_t read_len);
/************************************************************************************************
 *                                          Defines                                              *
 ************************************************************************************************/
#ifdef __cplusplus
};
#endif

#endif // __DEV──UART──TABLE_H
